-----------------------------------------------------------------------------
-- NFS Shift 2 track import
-- select the sgb file of the track you want to import
-- Be patient, it will take quite some time until it loads all of it!
-- i recommend at least 1GB of ram for this ;)
-- same objects are handled as instances
-- known bugs: some objects might be missing,
-- some textures are not shown in the viewport, but their path is set
-- many thanks to chipicao for his great help in research!
-- made by vagos21, script available at XenTaX forums (vagos21@yahoo.com)
------------------------------------------------------------------------------
struct theme(name, size, offset)
struct elmts(ID,firstAttr,numAttrs,numChildren,firstChild,nextSibling,numEltsSameType)
struct attrs(ID,type,val,num_values,nextAttr)
struct colls(ID,unknown1,unknown2,unknown3)

rootpath=""
matsarr = #() --materials array
matspaths = #() --material paths array
bitmapsarr = #() --bitmaps array
meshesarr = #() --meshes array
meshespaths = #() --mesh paths array

macroScript Shift2_track_import category:"myscripts"
(
	undo off
	
	--select car folder
	trackpath = getOpenFileName caption:"Select SGB file" types:"Object Preset(*.sgb)|*.sgb"
	print ("Importing Track: " + trackpath as string)
	
	--calculate root folder
	rootpath = (getFilenamePath trackpath)
	words = filterString trackpath "\\"
	apath=""
	for i=1 to words.count-3 do
	apath+= (words[i]+"\\")
	rootpath= apath
	print ("Root Path: " + rootpath)
	trackfolder= words[words.count-1]
	
	--clear arrays
	for i=1 to matsarr.count do (deleteItem matsarr 1)
	for i=1 to matspaths.count do (deleteItem matspaths 1)
	for i=1 to bitmapsarr.count do (deleteItem bitmapsarr 1)
	for i=1 to meshesarr.count do (deleteItem meshesarr 1)
	for i=1 to meshespaths.count do (deleteItem meshespaths 1)	
	
	--load track
	readTrack trackpath 
		
) --main

fn readTrack filename=
(
	f = fopen filename "rb"
	
	--jump everthing until we find summ!
	fseek f 16 #seek_set
	do
	(
		aName = ""
		for w=1 to 4 do (aName += (bit.intasChar(readByte f #unsigned)))
		size = readlong f #unsigned
		if (aName=="MMUS") then exit
		fseek f (size-8) #seek_cur
	) while true
	
	---------------------READ SUMM-----------------------
	numSumm=readlong f #unsigned
	for i=1 to numSumm do
	(
		beginning = ftell f
		size = readlong f #unsigned
		lng1 = readlong f #unsigned
		
		str = readlong f #unsigned
		pos = ftell f
		fseek f str #seek_set
		name1=readString f
		fseek f pos #seek_set
		
		lng2=readlong f #unsigned
		lng3=readlong f #unsigned
		lng4=readlong f #unsigned
		lng5=readlong f #unsigned
		
		str = readlong f #unsigned
		pos = ftell f
		fseek f str #seek_set
		name2=readString f
		fseek f pos #seek_set
		
		str = readlong f #unsigned
		pos = ftell f
		fseek f str #seek_set
		name3=readString f
		fseek f pos #seek_set
		
		if (name2=="OBJECT") then
		(
			str4=readlong f #unsigned
			pos = ftell f
			fseek f str4 #seek_set
			name4=readString f
			fseek f pos #seek_set
			
			lng6=readlong f #unsigned
			fl1=readfloat f
			fl2=readfloat f
			fl3=readfloat f
			
			lng7=readlong f #unsigned
			lng8=readlong f #unsigned
			fl4=readfloat f
			fl5=readfloat f
			fl6=readfloat f
		)
		
		if (name2=="LOD") then
		(
			lng6=readlong f #unsigned
			lng7=readlong f #unsigned
			fl1=readfloat f
			fl2=readfloat f
			fl3=readfloat f
			fl4=readfloat f
			
			lng8=readlong f #unsigned
			fl5=readfloat f
			fl6=readfloat f
			fl7=readfloat f
			fl8=readfloat f
			fl9=readfloat f
			fl10=readfloat f
			fl11=readfloat f
			fl12=readfloat f
			
			minus1=readlong f
			fl13=readfloat f
			
			lng8=readlong f #unsigned
			
			str = readlong f #unsigned
			pos = ftell f
			fseek f str #seek_set
			name4=readString f
			fseek f pos #seek_set
			
			str = readlong f #unsigned
			pos = ftell f
			fseek f str #seek_set
			name5=readString f
			fseek f pos #seek_set
			
			str = readlong f #unsigned
			pos = ftell f
			fseek f str #seek_set
			name6=readString f
			fseek f pos #seek_set
			
			if (name4=="OBJECT") then
			(
				lng9=readlong f #unsigned
				lng10=readlong f #unsigned
				fl14=readfloat f
				fl15=readfloat f
				fl16=readfloat f
				fl17=readfloat f
				
				orientation = quat -fl8 -fl10 -fl9 fl11
				position = [fl5, fl7, fl6]
				
				--get correct path of track object
				words = filterString filename "\\"
				apath=""
				for i=1 to words.count-3 do
				apath+= (words[i]+"\\")
				
				--check if object is already imported
				found=false
				amesh
				for i=1 to meshespaths.count do
				(
					if ((apath+name6)==meshespaths[i]) then
					(
						amesh=instance meshesarr[i] --use instance of already imported mesh
						found=true
						exit
					)
				)
				if ( not found) then --if it's not imported, add new mesh
				(
					amesh = importPart (apath+name6)
				)
				--apply position and orientation
				amesh.pos = position
				rotate amesh orientation
			)
		)
		
		--jump remaining SUMM bytes
		fseek f (size-((ftell f)-beginning)) #seek_cur
		
	)

	fclose f
) --read track

fn importPart filename=
(
	farr = #() --faces array
	varr = #() --vertex positions array
	UVWarr = #() --vertex UV coords array
	faceMatID = #() --material ID of face
	
	--open file
	f = fopen filename "rb"
	
	--jump first 8 bytes
	b1=readbyte f #unsigned
	b2=readbyte f #unsigned
	b3=readbyte f #unsigned
	b4=readbyte f #unsigned
	b5=readbyte f #unsigned
	b6=readbyte f #unsigned
	b7=readbyte f #unsigned
	b8=readbyte f #unsigned
	--if it's animation file, exclude it
	if b5==1 then 
	(
		print (filename+" is an animated mesh, will not be imported!")
		fclose f
		return 0
	)
	
	--read part name
	partName = (readString f)
	print ("Loading: " + partName)
	
	--jump remaining alignment zero bytes
	multiplier = (partName.count+1)/4
	if ( (mod (partName.count+1) 4) !=0 ) then
	(
		bytesToJump= ((multiplier+1)*4) - (partName.count+1)
		fseek f bytesToJump #seek_cur
	)
	
	--read number of vertices
	numVerts = readlong f #unsigned
	
	--read number of vertex properties
	numVertProps = readlong f #unsigned

	--read number of primitives
	numPrims = readlong f #unsigned
	
	--jump 10 unknown floats
	fseek f 40 #seek_cur

	------------------------------read vertex properties---------------------------
	for prop=1 to numVertProps do
	(
		rec1 = readlong f #unsigned
		rec2 = readlong f #unsigned
		rec3 = readlong f #unsigned
--print (rec1 as string + " " + 	rec2 as string + " " + rec3 as string)	

		if (rec1==2 and rec2==0 and rec3==0) then --read positions
		(
			for v = 1 to numverts do
			(
				avert = [0.,0.,0.]
				x=readfloat f
				y=readfloat f
				z=readfloat f
				avert.x = x
				avert.y = z
				avert.z = y
				append varr avert
			)
		)
		
		if (rec1==4 and rec2==6 and rec3==0) then --jump colors
		( fseek f (numverts*4) #seek_cur )
		
		if (rec1==2 and rec2==2 and rec3==0) then --jump normals
		( fseek f (numverts*12) #seek_cur )
		
		if (rec1==1 and rec2==3 and rec3==0) then --read UVs
		(
			for v = 1 to numverts do
			(
				aUVW = [readfloat f, -readfloat f, 0.0]
				append UVWarr aUVW
			)
		)
		
		if (rec1==0 and rec2==3 and rec3==3) then --jump zeroes..!?
		( fseek f (numverts*4) #seek_cur )
		
		if (rec1==2 and rec2==4 and rec3==0) then --jump ??
		( fseek f (numverts*12) #seek_cur )
		
		if (rec1==2 and rec2==5 and rec3==0) then --jump ??
		( fseek f (numverts*12) #seek_cur )	
		
		if (rec1==1 and rec2==3 and rec3==2) then --jump UV set
		( fseek f (numverts*8) #seek_cur )
		
		if (rec1==1 and rec2==3 and rec3==1) then --jump UV set
		( fseek f (numverts*8) #seek_cur )
		
		if (rec1==2 and rec2==3 and rec3==0) then --jump ??
		( fseek f (numverts*12) #seek_cur )	
		
		if (rec1==2 and rec2==3 and rec3==1) then --jump ??
		( fseek f (numverts*12) #seek_cur )	
		
		if (rec1==1 and rec2==3 and rec3==4) then --jump UV set
		( fseek f (numverts*8) #seek_cur )
		
		if (rec1==1 and rec2==3 and rec3==3) then --jump UV set
		( fseek f (numverts*8) #seek_cur )
		
		if (rec1==4 and rec2==6 and rec3==1) then --jump colors
		( fseek f (numverts*4) #seek_cur )
		
		
	) --end reading vertex properties
		
	--prepare a multi-material for each object
	mm =multimaterial numsubs:numPrims

	-----------------------------read face properties-------------------------------
	for p=1 to numPrims do
	(
		--get material
		matname = readstring f --material file name path
		matfilename = ((substring matname 1 (matname.count-3))+"bmt")
		amat = standard name: " "
		found = false
		for i=1 to matspaths.count do
		(
			if ((rootpath+matfilename)==matspaths[i]) then
			(
				amat=matsarr[i] --use instance of already imported material
				found=true
				exit
			)
		)
		if (not found) then --if it's not imported, add new mesh
		(
			amat = readMaterial (rootpath+matfilename)
		)
		mm[p]=amat
		
		--jump remaining alignment zero bytes
		multiplier = (matfilename.count+1)/4
		if ( (mod (matfilename.count+1) 4) !=0 ) then
		(
			bytesToJump= ((multiplier+1)*4) - (matfilename.count+1)
			fseek f bytesToJump #seek_cur
		)
		
		--jump a long of zeros
		fseek f 4 #seek_cur
		
		--read number of faces
		numFaces = readlong f
		
		--set face ID
		for face=1 to numFaces do
		(
			append faceMatID p
		)
		
		--read faces
		for face=1 to numFaces do
		(
			ind1 = readshort f #unsigned
			ind2 = readshort f #unsigned
			ind3 = readshort f #unsigned
			aface = [ind1+1,ind3+1,ind2+1]
			append farr aface
		)
		
		--jump alignment zero bytes
		pos=ftell f
		multiplier = pos/4
		if ( (mod pos 4) !=0 ) then
		(
			bytesToJump= ((multiplier+1)*4) - pos
			fseek f bytesToJump #seek_cur
		)
		
		--read 2 shorts of some face index
		short1=readshort f #unsigned
		short2=readshort f #unsigned
		
		--jump 10 floats
		fseek f 40 #seek_cur
		
	) --read primitives
	
	--close file
	fclose f
	
	--build mesh	
	amesh = mesh vertices:varr faces:farr name:partname
	
	--apply uvw tex coords to mesh
	applyuvw amesh UVWarr
	
	--apply multi-material to mesh
	if numPrims==1 then
	(
		amesh.material = mm[1]
	)else(
		amesh.material = mm
	)
	
	--apply material IDs to mesh faces
	for i=1 to faceMatID.count do
	(
		setFaceMatID amesh i faceMatID[i]
	)
	
	--add new mesh to meshes array
	append meshesarr amesh
	append meshespaths filename
	
	return amesh
	
) --importPart

fn readMaterial filename =
(
	--------------------------------READ MATERIAL FILE------------------------------
	f = fopen filename "rb"
	
	themesArr = #() --stuff at top
	elmt = #()
	attr = #()
	coll = #()
	numb = #()
	bool = #()
	strs = #()
	
	--read stuff at top of file
	for i=1 to 8 do
	(
		aName = ""
		for w=1 to 4 do (aName += (bit.intasChar(readByte f #unsigned)))
		aSize = readlong f #unsigned
		aOffset = readlong f #unsigned
		aZero = readlong f #unsigned
		atheme = theme aName aSize aOffset
		append themesArr atheme
	)
	
	--HEAD
	fseek f (themesArr[2].offset) #seek_set
	num_elts = readlong f #unsigned
	num_attr = readlong f #unsigned
	num_coll = readlong f #unsigned
	num_numb = readlong f #unsigned
	num_strs = readlong f #unsigned
	num_bool = readlong f #unsigned
	unknown1 = readlong f #unsigned
	
	--ELMT
	fseek f (themesArr[3].offset) #seek_set
	for i =1 to num_elts do
	(
		ID=readlong f #unsigned
		firstAttr=readlong f #unsigned
		numAttrs=readlong f #unsigned
		numChildren=readlong f #unsigned
		firstChild=readlong f #unsigned
		nextSibling=readlong f #unsigned
		numEltsSameType=readlong f #unsigned
		aelmt = elmts ID firstAttr numAttrs numChildren firstChild nextSibling numEltsSameType
		append elmt aelmt
	)
	
	--ATTR
	fseek f (themesArr[4].offset) #seek_set
	for i =1 to  num_attr do
	(
		ID=readlong f #unsigned
		type=readlong f #unsigned
		val=readlong f #unsigned
		num_values=readlong f #unsigned
		nextAttr=readlong f #unsigned
		aattr = attrs ID type val num_values nextAttr
		append attr aattr
	)
	
	--COLL
	fseek f (themesArr[5].offset) #seek_set
	for i =1 to  num_coll do
	(
		ID=readlong f #unsigned
		unknown1=readlong f #unsigned
		unknown2=readlong f #unsigned
		unknown3=readlong f #unsigned
		acoll = colls ID unknown1 unknown2 unknown3
		append coll acoll
	)
	
	--NUMB
	fseek f (themesArr[6].offset) #seek_set
	for i =1 to  num_numb do
	(
		append numb (readfloat f)
	)
	
	--BOOL
	fseek f (themesArr[7].offset) #seek_set
	for i =1 to  4 do
	(
		append bool (readbyte f #unsigned)
	)
	
	--STRS
	fseek f (themesArr[8].offset) #seek_set
	for i =1 to  themesArr[8].size do
	(
		append strs (bit.intasChar(readByte f #unsigned))
	)
	
	--close file
	fclose f
	
	words = filterString filename "\\"
	texpath=""
	for i=1 to words.count-3 do
		texpath+= (words[i]+"\\")
	
-----------------------------BUILD MATERIAL-----------------------------	
	amaterial = standard showInViewport:true Name: (getFilenameFile filename)
	previousattrib="" --keep last name for texture path'
	for i=1 to num_attr do
	(
		if attr[i].type==2 then --STRINGS
		(
			--take attribute name from characters array
			attribname=""
			startoffset=attr[i].val
			offadd=1
			do
			(
				achar =strs[startoffset+offadd]
				attribname += achar
				offadd += 1
			)while (achar != "")
			
			--take textures according to attrib name
			case attribname of
			(
				"diffuseTexture" :
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.diffuseMap=bitmapsarr[t]
							amaterial.opacityMap=bitmapsarr[t]
							amaterial.opacityMap.monoOutput=1
							found=true
							exit
						)
					)
					if (not found) then
					(
						adiffusemap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.diffuseMap=(adiffusemap)
						aopacitymap = Bitmaptexture fileName: (texpath+previousattrib) monoOutput:1
						amaterial.opacityMap=(aopacitymap)
						append bitmapsarr adiffusemap
					)
				)
				"specularTexture" :
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.specularLevelMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						aglossmap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.specularLevelMap=(aglossmap)
						append bitmapsarr aglossmap
					)
				)
				"normalTexture" :
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.bumpMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						anormalmap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.bumpMap=(anormalmap)
						append bitmapsarr anormalmap
					)
				)
				"middleDiffuseTexture":
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.diffuseMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						adiffusemap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.diffuseMap=(adiffusemap)
						append bitmapsarr adiffusemap
					)
				)
				"middleDiffuseTexture1":
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.diffuseMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						adiffusemap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.diffuseMap=(adiffusemap)
						append bitmapsarr adiffusemap
					)
				)
				"baseDSTexture":
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.diffuseMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						adiffusemap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.diffuseMap=(adiffusemap)
						append bitmapsarr adiffusemap
					)
				)
				"layer1DiffuseTexture":
				(
					found=false
					for t=1 to bitmapsarr.count do
					(
						if (matchPattern (bitmapsarr[t].fileName) pattern: ("*"+previousattrib) ) then
						(
							amaterial.diffuseMap=bitmapsarr[t]
							found=true
							exit
						)
					)
					if (not found) then
					(
						adiffusemap = Bitmaptexture fileName: (texpath+previousattrib)
						amaterial.diffuseMap=(adiffusemap)
						append bitmapsarr adiffusemap
					)
				)
			)
			if attr[i].val>0 then  previousattrib=attribname --keep last name for texture path'
		)
	)
	
	append matsarr amaterial
	append matspaths filename

	return amaterial
) --readMaterials

fn applyuvw anode auvarray	= --applies UVW to node
(
	if (auvarray.count > 0) then (
		anode.numtverts = anode.numverts
		buildtvfaces anode
		for vi = 1 to anode.numverts do (
			settvert anode vi auvarray[vi]
		)				
		allfaces = #()
		for fi = 1 to anode.numfaces do (
			crtface = getface anode fi
			append allfaces crtface
		)
		for fi = 1 to anode.numfaces do (
			settvface anode fi allfaces[fi]
		)
	)
) --apply UV mapping to node
